<?xml version="1.0" encoding="utf-8" ?>
<doctrine-mapping
        xmlns="http://doctrine-project.org/schemas/orm/doctrine-mapping"
        xmlns:gedmo="http://gediminasm.org/schemas/orm/doctrine-extensions-mapping"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:schemaLocation="http://doctrine-project.org/schemas/orm/doctrine-mapping
                            https://raw.github.com/doctrine/doctrine2/master/doctrine-mapping.xsd">

    <entity name="App\Domain\Registry\Model\Contractor" table="registry_contractor">

        <id name="id" column="id" type="uuid"/>

        <field name="name" column="name"/>
        <field name="referent" column="referent" nullable="true"/>
        <field name="contractualClausesVerified" column="contractual_clauses_verified" type="boolean"/>
        <field name="conform" column="conform" type="boolean"/>
        <field name="otherInformations" column="other_informations" type="text" nullable="true"/>

        <embedded name="address" class="App\Domain\Registry\Model\Embeddable\Address" column-prefix="address_"/>

        <many-to-many field="treatments" target-entity="App\Domain\Registry\Model\Treatment" mapped-by="contractors"/>
        <many-to-many field="proofs" target-entity="App\Domain\Registry\Model\Proof" mapped-by="contractors">
            <order-by>
                <order-by-field name="name"/>
            </order-by>
        </many-to-many>
        <many-to-one field="clonedFrom" target-entity="App\Domain\Registry\Model\Contractor"/>

        <!-- Traits -->
        <many-to-one field="collectivity" target-entity="App\Domain\User\Model\Collectivity"/>
        <many-to-one field="creator" target-entity="App\Domain\User\Model\User"/>
        <field name="createdAt" column="created_at" type="datetime_immutable">
            <gedmo:timestampable on="create"/>
        </field>
        <field name="updatedAt" column="updated_at" type="datetime_immutable">
            <gedmo:timestampable on="update"/>
        </field>

    </entity>

</doctrine-mapping>
